#pragma once


/*
	CDockingPluginManager
	hbLOvOCp̃}l[WONX
*/

#include "resource.h"
#include "MtlUpdateCmdUI.h"
#include "DockingChildBase.h"


/*
	CDockingPluginWindow
	hbLOvOCp̃EBhENX

	ɉĂȂ
*/


class CDockingPluginWindow : public CDockingChildBaseT<CDockingPluginWindow>
{
protected:
	HWND m_hWndPlugin;

public:
	CDockingPluginWindow();

	void SetPluginWindow(HWND hWnd);
	void Resize();

	BEGIN_MSG_MAP(CDockingPluginWindow)
		MESSAGE_HANDLER(WM_SIZE,OnSize)
		CHAIN_MSG_MAP(CDockingChildBaseT<CDockingPluginWindow>)
	END_MSG_MAP()

	LRESULT OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
};


class CDockingPluginManager
{
protected:
	//oϐ
	std::vector<CDockingPluginWindow*> m_vecWindow;

	//nh
	LRESULT OnDockingPluginMenu(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	BOOL OnUpdateDockingMenuState(int nIndex, CCmdUI *pCmdUI);

	//萔
	enum { cnt_menu_view_pos = 2,  //u\v̈ʒu
		   cnt_menu_docking_pos = 3,//uhbLOo[v̈ʒu
	};

public:

	//RXgN^EfXgN^
	CDockingPluginManager();
	~CDockingPluginManager();

	//\bh
	bool Init(HWND hWndFrame, CMenuHandle& menu);
	bool Clear();
	BOOL PreTranslateMessage(MSG *pMsg);

	//Agr[g
	int GetCount();
	CDockingPluginWindow* GetWindow(int nIndex);

	//bZ[W}bv
	BEGIN_MSG_MAP(CDockingPluginManager)
		COMMAND_RANGE_HANDLER(ID_DOCKINGPLUGIN_FIRST,ID_DOCKINGPLUGIN_LAST,OnDockingPluginMenu)
	END_MSG_MAP()

	//UIXV}bv
	BEGIN_UPDATE_COMMAND_UI_MAP(CDockingPluginManager)
		if(ID_DOCKINGPLUGIN_FIRST <= nID && nID <= ID_DOCKINGPLUGIN_LAST){
			return OnUpdateDockingMenuState(nID-ID_DOCKINGPLUGIN_FIRST, pCmdUI);
		}
	END_UPDATE_COMMAND_UI_MAP()
};



