#pragma once


#include <stdlib.h> // for mbstowcs(), wcstombs()
#include <locale.h> // for setlocale()


/*
	CStringEncoder
	ANSI(SJIS)EUCUTF-8ɕϊURLGR[hNX

	google񂪎󂯕tURLGR[ȟ`UTF-8Ȃ̂
	SJISUTF-16UTF-8ɕϊURLGR[hs܂B
	ϊ[`[Jh](http://kamoland.com/comp/unicode.html)
	q؂ĂĂ܂B

	UNICODE̕ϊɂ͂܂ΉĂ܂B
*/

class CURLEncoder
{
public:

	//CString͍̓͂̂Ƃchar(ANSIstring)̂ݑz
	void URLEncode_SJIS(CString& str);	//SJISURLGR[h
	void URLEncode_EUC(CString& str);	//EUCURLGR[h
	void URLEncode_UTF8(CString& str);	//UTF8URLGR[h

private:

	LPSTR sjis_to_utf8(LPCSTR pAnsiStr, int *nBytesOut);
	LPWSTR sjis_to_utf16be(LPCSTR pAnsiStr, int *nBytesOut);
	LPSTR utf16be_to_utf8(LPCWSTR pUcsStr, int *nBytesOut);
	int utf16be_to_utf8_sub(LPSTR pUtf8, LPCWSTR pUcs2, int nUcsNum, BOOL bCountOnly);

	BOOL NotEncodeChar(int code);
};

